using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.IO;

public partial class Admin_frmAddDocument : System.Web.UI.Page
{
    clsDocuments_Logic objDocument = new clsDocuments_Logic();
    clsCommon_Logic objCommon = new clsCommon_Logic();
    clsCategory_Logic objCategory = new clsCategory_Logic();
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            BindCategory();
            BindStatus();
        }
    }

    public void BindStatus()
    {
        DataSet dsStatus = objCommon.GetStatusName();
        ddlStatus.DataSource = dsStatus.Tables[0];
        ddlStatus.DataTextField = "StatusName";
        ddlStatus.DataValueField = "StatusId";
        ddlStatus.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlStatus.Items.Insert(0, li);

    }
    public void BindCategory()
    {
        DataSet dsCategory = objCategory.GetCategory();
        ddlCategory.DataSource = dsCategory.Tables[0];
        ddlCategory.DataTextField = "CategoryName";
        ddlCategory.DataValueField = "CategoryId";
        ddlCategory.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlCategory.Items.Insert(0, li);
    }
    protected void btnSubmit_Click(object sender, EventArgs e)
    {
        objDocument.DocumentTitle = txtDocumentTitle.Text.Trim();
        objDocument.StatusId = Convert.ToInt32(ddlStatus.SelectedItem.Value);
        objDocument.CategoryId = Convert.ToInt32(ddlCategory.SelectedItem.Value);
        objDocument.ShortDesc = txtShortDesc.Text.Trim();
        objDocument.FullDesc = txtShortDesc.Text.Trim();
        objDocument.KeyWords = txtKeyWords.Text.Trim();
        if (Session["UserName"] != null)
        {
            objDocument.SubmittedBy = Session["UserName"].ToString();
            objDocument.UserId = Convert.ToInt32(Session["UserId"].ToString());
        }
        if (Session["AdminId"] != null)
        {
            objDocument.SubmittedBy = Session["AdminId"].ToString();
            objDocument.UserId = 100;
        }
        if (fileuploadDoc.PostedFile.FileName != "")
        {
            string docType;
            int docSize;
            string docName;
            string Doc_Repository_FolderName;
            docType = fileuploadDoc.PostedFile.ContentType;
            if (docType == "application/msword" || docType == "text/plain" || docType == "application/pdf" || docType == "application/vnd.ms-excel" || docType == "application/x-xml" || docType == "application/vnd.ms-publisher" || docType == "application/vnd.ms-powerpoint")
            {
                docSize = fileuploadDoc.PostedFile.ContentLength;
                if (docSize > 1000000)
                {
                    lblError.Visible = true;
                    lblError.Text = "please upload a document of size below 1MB only";
                    return;
                }
                else
                {
                    docName = Path.GetFileName(fileuploadDoc.PostedFile.FileName);
                    objDocument.DocumentUpload = docName;
                    lblError.Visible = false;
                }
                Doc_Repository_FolderName = Server.MapPath("../" + ConfigurationManager.AppSettings["Document"]);
                if (!Directory.Exists(Doc_Repository_FolderName))
                {
                    Directory.CreateDirectory(Doc_Repository_FolderName);
                }
                fileuploadDoc.PostedFile.SaveAs(Doc_Repository_FolderName + docName);

            }
            else
            {
                lblError.Visible = true;
                lblError.Text = "Please upload a document *.txt,*.pdf,*.doc,*.xls,*.ppt format only ";
            }
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = "Please upload a document";
        }
        objDocument.AddDocument();
        Response.Redirect("frmManageDocument.aspx");
    }
    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect("frmManageDocument.aspx");
    }
}
