using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

public partial class Admin_frmUpdateDocument : System.Web.UI.Page
{
    clsDocuments_Logic objDocument = new clsDocuments_Logic();
    clsCommon_Logic objCommon = new clsCommon_Logic();
    clsCategory_Logic objCategory = new clsCategory_Logic();
    string m_strFolderName = "";
    string strAimage = "";
    string ImageName = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            if (Request["Id"] != null)
            {
                ViewState["Id"] = Request["Id"].ToString();
            }
            else
            {
                Response.Redirect("frmManageDocument.aspx");
            }

            BindCategory();
            BindStatus();
            BindData();
        }
    }

    public void BindStatus()
    {
        DataSet dsStatus = objCommon.GetStatusName();
        ddlStatus.DataSource = dsStatus.Tables[0];
        ddlStatus.DataTextField = "StatusName";
        ddlStatus.DataValueField = "StatusId";
        ddlStatus.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlStatus.Items.Insert(0, li);

    }
    public void BindCategory()
    {
        DataSet dsCategory = objCategory.GetCategory();
        ddlCategory.DataSource = dsCategory.Tables[0];
        ddlCategory.DataTextField = "CategoryName";
        ddlCategory.DataValueField = "CategoryId";
        ddlCategory.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlCategory.Items.Insert(0, li);
    }

    protected void BindData()
    {
        objDocument.DecumentId = Convert.ToInt32(ViewState["Id"].ToString());
        objDocument.GetDocumentDetails();
        txtDocumentTitle.Text = objDocument.DocumentTitle;
        ViewState["doc"] = objDocument.DocumentUpload;
        txtShortDesc.Text = objDocument.ShortDesc;
        txtFullDesc.Text = objDocument.FullDesc;
        txtKeyWords.Text = objDocument.KeyWords;
        int StatusIndex = ddlStatus.Items.IndexOf(ddlStatus.Items.FindByValue(objDocument.StatusId.ToString()));
        if (StatusIndex >= 0)
            ddlStatus.Items[StatusIndex].Selected = true;

        int CatIndex = ddlCategory.Items.IndexOf(ddlCategory.Items.FindByValue(objDocument.CategoryId.ToString()));
        if (CatIndex >= 0)
            ddlCategory.Items[CatIndex].Selected = true;


        string FolderPath = Server.MapPath("../" + ConfigurationManager.AppSettings["Document"]);
        string Fname = ViewState["doc"].ToString();
        string strFilepath = FolderPath + Fname;
        if (System.IO.File.Exists(strFilepath))
        {
            hlnkViewFile.Text = "View File";
            hlnkViewFile.NavigateUrl = "../" + ConfigurationManager.AppSettings["Document"] + ViewState["doc"].ToString();
            hlnkViewFile.Target = "_blank";
            lnktbn_DeleteFile.Visible = true;
            hlnkViewFile.Visible = true;
            Label_NoFile.Visible = false;
        }
        else
        {
            lnktbn_DeleteFile.Visible = false;
            hlnkViewFile.Visible = false;
            Label_NoFile.Visible = true;
        }
    }
    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        objDocument.DecumentId = Convert.ToInt32(ViewState["Id"].ToString());
        objDocument.DocumentTitle = txtDocumentTitle.Text.Trim();
        objDocument.StatusId = Convert.ToInt32(ddlStatus.SelectedItem.Value);
        objDocument.CategoryId = Convert.ToInt32(ddlCategory.SelectedItem.Value);
        objDocument.ShortDesc = txtShortDesc.Text.Trim();
        objDocument.FullDesc = txtShortDesc.Text.Trim();
        objDocument.KeyWords = txtKeyWords.Text.Trim();

        if (ViewState["doc"] == null || ViewState["doc"].ToString()=="")
        {
            if (fileuploadDoc.PostedFile.FileName != "")
            {
                string docType;
                int docSize;
                string docName;
                string Doc_Repository_FolderName;
                docType = fileuploadDoc.PostedFile.ContentType;
                if (docType == "application/msword" || docType == "text/plain" || docType == "application/pdf" || docType == "application/vnd.ms-excel" || docType == "application/x-xml" || docType == "application/vnd.ms-publisher" || docType == "application/vnd.ms-powerpoint")
                {
                    docSize = fileuploadDoc.PostedFile.ContentLength;
                    if (docSize > 1000000)
                    {
                        lblError.Visible = true;
                        lblError.Text = "please upload a document of size below 1MB only";
                        return;
                    }
                    else
                    {
                        docName = Path.GetFileName(fileuploadDoc.PostedFile.FileName);
                        objDocument.DocumentUpload = docName;
                        lblError.Visible = false;
                    }
                    Doc_Repository_FolderName = Server.MapPath("../" + ConfigurationManager.AppSettings["Document"]);
                    if (!Directory.Exists(Doc_Repository_FolderName))
                    {
                        Directory.CreateDirectory(Doc_Repository_FolderName);
                    }
                    fileuploadDoc.PostedFile.SaveAs(Doc_Repository_FolderName + docName);

                }
                else
                {
                    lblError.Visible = true;
                    lblError.Text = "Please upload a document *.txt,*.pdf,*.doc,*.xls,*.ppt format only ";
                    return;
                }
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = "Please upload a document";
                return;
            }
        }
        else
        {
            objDocument.DocumentUpload = ViewState["doc"].ToString();
        }
        objDocument.UpdateDocument();
        Response.Redirect("frmManageDocument.aspx");

    }
    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect("frmManageDocument.aspx");
    }
    protected void lnktbn_DeleteFile_Click(object sender, EventArgs e)
    {
        m_strFolderName = Server.MapPath("../" + ConfigurationManager.AppSettings["Document"]);
        ImageName = ViewState["doc"].ToString();
        string strFpath = m_strFolderName + ImageName;
        if (System.IO.File.Exists(strFpath))
        {
            File.Delete(strFpath);
        }
        objDocument.DeleteDocumentfile(Convert.ToInt32(ViewState["Id"].ToString()));

        ViewState["doc"] = null;
        Label_NoFile.Visible = true;
        lnktbn_DeleteFile.Visible = false;
        hlnkViewFile.Visible = false;
    }
}
