using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_frmDocumentDetails : System.Web.UI.Page
{
    string docName;
    clsDocuments_Logic objDocument = new clsDocuments_Logic();
    clsCommon_Logic objCommon = new clsCommon_Logic();
    clsCategory_Logic objCategory = new clsCategory_Logic();
    clsRatingComments_Logic objRatingComments = new clsRatingComments_Logic();
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            if (Request["Id"] != null)
            {
                ViewState["Id"] = Request["Id"].ToString();
            }
            else
            {
                Response.Redirect("frmSearch.aspx");
            }
            BindData();
            BindRating();
        }
    }
    void BindRating()
    {
        DataTable dtTemp;
        dtTemp = objRatingComments.GetAllRatings(Convert.ToInt32(ViewState["Id"].ToString())).Tables[0];
        int CountPerson = 0;
        ViewState["Rating"] = 0;
        if (dtTemp.Rows.Count > 0)
        {
            CountPerson = dtTemp.Rows.Count;
            DataRowCollection drc = dtTemp.Rows;
            foreach (DataRow dr in drc)
            {
                ViewState["Rating"] = Convert.ToInt32(ViewState["Rating"].ToString()) + Convert.ToInt32(dr["Rating"].ToString());
            }
            decimal RatingAvg = Convert.ToInt32(ViewState["Rating"].ToString()) / CountPerson;
            lblRatings.Text = RatingAvg.ToString() + " Out Of 5";
        }
        else
        {
            lblRatings.Text = "No Rating has given";
        }
        
    }
    protected void BindData()
    {
        objDocument.DecumentId = Convert.ToInt32(ViewState["Id"].ToString());
        objDocument.GetDocumentDetails();
        lblDocumentTitle.Text = objDocument.DocumentTitle;
        ViewState["doc"] = objDocument.DocumentUpload;
        docName = ViewState["doc"].ToString();
        lblShortDescription.Text = objDocument.ShortDesc.ToString().Replace("\n","<br>");
        lblFullDescription.Text = objDocument.FullDesc.ToString().Replace("\n", "<br>");
        lblKeyword.Text = objDocument.KeyWords;
        lblStatus.Text = objDocument.StatusName;
        lblCategory.Text = objDocument.CategoryName;

        string file = ViewState["doc"].ToString();
        if (file != "" && file != null)
        {
            string filePath = Server.MapPath("UploadedDocuments/" + file);
            if(System.IO.File.Exists(filePath))
            {
                hlnkFileUpload.Text = ViewState["doc"].ToString();
                hlnkFileUpload.NavigateUrl = "~/UploadedDocuments/" + ViewState["doc"].ToString();
                hlnkFileUpload.Target = "_blank";
                
            }
            else
            {
                hlnkFileUpload.Text = "No File available for Download";
                
            }
        }
    }
   
    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect("frmSearch.aspx");
    }
    protected void btnSubmit_Click(object sender, EventArgs e)
    {
        ViewState["select"] = "";
        lblError.Visible = false;
        foreach (ListItem li in rdblRatings.Items)
        {
            if (li.Selected == true)
            {
                ViewState["select"] = "selected";
                break;
            }
            else
            {
                ViewState["select"] = "";
            }
        }
        if (ViewState["select"].ToString() != "selected")
        {
            lblError.Text = "Please fill all * mark fields";
            lblError.Visible = true;
            return;
        }
        if (txtWriteComments.Text.Trim() == "" || txtYourName.Text.Trim() == "" || txtEmailID.Text.Trim() == "")
        {
            lblError.Text = "Please fill all * mark fields";
            lblError.Visible = true;
            return;
        }

        foreach (ListItem li in rdblRatings.Items)
        {
            if (li.Selected == true)
            {
                objRatingComments.Pro_Rating =Convert.ToInt32(li.Value.ToString());
            }
        }
        objRatingComments.Pro_Comments = txtWriteComments.Text.Trim();
        objRatingComments.Pro_CommentsBy = txtYourName.Text.Trim();
        objRatingComments.Pro_CommentsPersonEmailId = txtEmailID.Text.Trim();
        try
        {
            if (objRatingComments.GetAlreadyGivenRatingByPerson(Convert.ToInt32(ViewState["Id"].ToString())) == 0)
            {
                objRatingComments.AddRatingComments(Convert.ToInt32(ViewState["Id"].ToString()));
                Response.Write("<script>alert('Comments Added Successfully')</script>");
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = "You Have Already Given Rating for This Documents/Articles/Information";
                return;
            }
        }
        catch (Exception ex)
        {
            lblError.Visible = true;
            lblError.Text = ex.Message;
        }
    }
}
